//Seekbuttons.m:  My bitch.  This is *loosely* based on the concept of the autorepeating script by...?  Anyway,
//I say loosely based due to the fact that I didn't actually try to mock the code used in the afformentioned script,
//I just mention it because it's where the idea came from.  I wanted to have back and forward buttons that also
//had seek actions when held, and here's how I did it.  I'm not sure if this was ever corrected in the ARVB script, but
//the seek speed actually accelerates the longer you hold it, and then slows again if it skips to the next song.
//All code by me, Digitalhigh.
//-----------------------------------------------------------
//How to use this for your own fun:
//(Sample XML)
//<groupdef id="whatever">
//	<button id="previous" action="" image="btn.prev".../>
//	<button id="next" action="" image="btn.next".../>
//	<script id="seekbuttons" file="scripts/seekbuttons.maki"/>
//</groupdef>
//
//Now all you've got to do is compile this and go to town.
//-----------------------------------------------------------

// never forget to include std.mi
#include </lib/std.mi>

// declarations
global button back, forward;
global int b1, b2, p1, p2, a1, a2;
global timer buttontimer1, buttontimer2;
global group pgroup;
global boolean time1, time2;


system.onscriptloaded() {

	pgroup = getscriptgroup(); //finds the group the buttons are in.

	back = pgroup.findobject("previous");  //finds our buttons
	forward = pgroup.findobject("next");

	buttontimer1 = new timer;  //makes the timers and sets their delay
	buttontimer1.setdelay(1);

	buttontimer2 = new timer;
	buttontimer2.setdelay(1);

}  //ends the onscriptloaded command


system.onscriptunloading() {

	delete buttontimer1;
	delete buttontimer2;

}


back.onleftbuttondown(int x, int y) {
	buttontimer1.start();  //starts the timer when you click down

}


back.onleftbuttonup(int x, int y) {
	buttontimer1.stop();  //stops the timer
	if (time1==0) {            //checks to see if you've held the button down long enough
		system.previous();  //if not, just acts like a normal button
		time1=0;   //resets the counter
	}

	B1=0; //sets the timer back to 0
	a1=100;  //sets the seek speed back to 100

}

forward.onleftbuttondown(int x, int y) {
	buttontimer2.start();

}


forward.onleftbuttonup(int x, int y) {
	buttontimer2.stop();
	if (time2==0) {
		system.next();
		time2=0;
	}

	b2=0;
	a2=100;

}

buttontimer1.ontimer() {

	if (b1>=50) {    //checks to see if counter at bottom has reached 50 ms yet
		time1=1;  //flag for the onbuttonup command so it knows what to do
		p1=System.getposition();  //gets the current song position
		p1-=a1;  //sets the position back by a1, which is currently 100
		a1+=50;  //adds 50 to it, so the seekspeed increases
		if (p1<=0) {  //if we get to the end of the song
			System.previous();  //skip to the previous song
			a1=100;  //resets the seeksepeed to 100 again
                        p1=((System.getPlayItemLength() * 1000)-1); // gets the length of the song and goes to the end
			system.seekto(p1);//starts seeking back again
			system.play();  //triggers the play command to show the new song
		} else {
		system.seekTo(p1);   //otherwise, seek backwards
		}
	}

	b1+= 1;  //adds one to the counter
}

buttontimer2.ontimer() {

	if (b2>=50) {
		time2=1;
		p2=System.getposition();
		p2+=a2;
		a2+=50;
		if (p2>=System.getPlayItemLength() + 5) {
			System.next();
			a2=100;
			p2=(0);
		} else {
		system.seekTo(p2);
		}
	}
	b2+=1;
}


